Bug 1738805 - condor depends on Python 2
Summary: condor depends on Python 2
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: condor
Version: 31
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Tim Theisen
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: F31_PY2REMOVAL
TreeView+ depends on / blocked
 
Reported: 2019-08-08 08:31 UTC by Lumír Balhar
Modified: 2021-07-26 12:55 UTC (History)
10 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-10-06 20:55:31 UTC
Type: Bug


Attachments (Terms of Use)

Description Lumír Balhar 2019-08-08 08:31:27 UTC
Python 2.7 will reach end-of-life in January 2020, over 9 years after it was released. This falls within the Fedora 31 lifetime.
Packages that depend on Python 2 are being switched to Python 3 or removed from Fedora: https://fedoraproject.org/wiki/Changes/F31_Mass_Python_2_Package_Removal#Information_on_Remaining_Packages
Python 2 will be retired in Fedora 32: https://fedoraproject.org/wiki/Changes/RetirePython2

To help planning, we'd like to know the plans for condor's future. Specifically:


- What is the reason for the Python2 dependency? (Is it software written in Python, or does it just provide Python bindings, or use Python in the build system or test runner?) 

- What are the upstream/community plans/timelines regarding Python 3?

- What is the guidance for porting to Python 3? (Assuming that there is someone who generally knows how to port to Python 3, but doesn't know anything about the particular package, what are the next steps to take?)


This bug is filed semi-automatically, and might not have all the context specific to condor.
If you need anything from us, or something is unclear, please mention it here.

Thank you.

Comment 1 Tim Theisen 2019-08-12 15:49:44 UTC
Condor provides both Python 2 and Python 3 bindings.

The Python 3 bindings are not as mature as the Python 2 bindings. Specifically, Python 3 is much more aggressive about freeing memory associated with objects, and we are working on ensuring adequate references to prevent premature garbage collection. At this point, scripts that should work using the Python 3 bindings can crash the Python interpreter. We plan to fix these issues in the next 2 months. At that point, we will drop the Python 2 bindings.

We are actively working on the Python 3 bindings. I am not sure that I can give any guidance for help at this time. I believe that specialized knowledge of the internals of the C++ libraries are required for the next steps.

Comment 2 Ben Cotton 2019-08-13 17:04:30 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to 31.

Comment 3 Lumír Balhar 2019-08-20 14:14:41 UTC
Nothing depends on python2-condor so this subpackage can be removed anytime.

When condor will be ready, we have to make sure that the main condor package depends only on Python 3. Now, it depends on both Python 2 and Python 3.

Just general info:
The current plan is to remove packages with dependency on Python 2 from Fedora 32 in the middle of November 2019. If you want to keep your package in Fedora after that date and you cannot port it to Python 3 yet, you need to request a FESCo exception for the package and all its Python 2 dependencies (even transitive) [1]. If you don't want to maintain it anymore, and nothing in Fedora uses it, you can retire it or just remove the Python 2 part from it (subpackage, module, bindings, etc.).

If you're considering filing the exception request, let us know. We can help (for example, we can help find all the dependencies).

[1] https://fedoraproject.org/wiki/Changes/RetirePython2#FESCo_exceptions


Note You need to log in before you can comment on or make changes to this bug.